/**
 * 
 */
package com.sonicsw.pso.demo.util;

import static com.sonicsw.pso.demo.util.IConstants.*;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.net.URI;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import com.sonicsw.pso.demo.config.Configuration;
import com.thoughtworks.xstream.XStream;

/**
 * @author Nick Rapoport - Copyright (c) - May 22, 2008 All rights reserved
 *
 */
public class MakeConfig {
    private static org.apache.log4j.Logger log = org.apache.log4j.Logger
            .getLogger(MakeConfig.class);
    private Configuration config;
    private static XStream xStream = new XStream();
    static {
        org.apache.log4j.PropertyConfigurator.configureAndWatch(LOG4J_INIT_PROPERTIES);
        xStream.alias("Configuration", Configuration.class);
        xStream.alias("MessageRoot", Map.class);
        xStream.registerConverter(new MessageRootMapConverter(xStream.getMapper()));
        }
    /**
     * 
     */
    public MakeConfig() {
        config = new Configuration();
    }

    /**
     * 
     */
    public MakeConfig(String url) {
        try {
            URI uri = URI.create(url);
            // xStream.createObjectInputStream(new java.io.FileInputStream()));
            config = (Configuration) xStream.fromXML(
                    new FileReader(new File(uri)));
        } catch (FileNotFoundException ex) {
            // TODO Auto-generated catch block
            log.error("Caught FileNotFoundException Message '"+url+"'" + 
            	ex.toString(),ex);
            //ex.printStackTrace(System.out);
            
        } catch (IllegalArgumentException ex) {
            // TODO Auto-generated catch block
            log.error("Caught URISyntaxException Message '"+url+"'"  + 
            	ex.toString(),ex);
            //ex.printStackTrace(System.out);
            
        }
        
    }

    public void storeConfig(String fname) {
        int cntr = 0;
        Map<String,String> elementTest = new HashMap<String,String>();
        for (Iterator<String> iter = config.getKeys().iterator(); iter.hasNext();) {
            String key = iter.next();
            elementTest.put(key, "value"+(++cntr));
        }
        String xml = xStream.toXML(config);
        String sample = xStream.toXML(elementTest);
        System.out.println(sample);
        try {
            Utilities.saveFile(fname, xml);
        } catch (ConfigurationException ex) {
            // TODO Auto-generated catch block
            log.error("Caught ConfigurationException Message " + 
            	ex.toString(),ex);
            //ex.printStackTrace(System.out);
            
        }
    }
    /**
     * @param args
     */
    public static void main(String[] args) {
        String fname = "./Configuration.xml";
        MakeConfig mc = null;
        if (args.length>0) {
            fname = args[0];
            mc = new MakeConfig(fname);
            mc.storeConfig(fname+".modified.xml");
        } else {
            mc = new MakeConfig();
            mc.config.add("Key");
            mc.config.add("Message");
            mc.storeConfig(fname);            
        }
        
    }
    
        
}
