/**
 * 
 */
package com.sonicsw.pso.demo.util;

import java.util.Iterator;
import java.util.Map;

import com.thoughtworks.xstream.converters.MarshallingContext;
import com.thoughtworks.xstream.converters.UnmarshallingContext;
import com.thoughtworks.xstream.converters.collections.MapConverter;
import com.thoughtworks.xstream.io.HierarchicalStreamReader;
import com.thoughtworks.xstream.io.HierarchicalStreamWriter;
import com.thoughtworks.xstream.mapper.Mapper;


/**
 * @author Nick Rapoport - Copyright (c) - May 28, 2008 All rights reserved
 *
 */
public class MessageRootMapConverter extends MapConverter {
    private static org.apache.log4j.Logger log = org.apache.log4j.Logger
    .getLogger(MapConverter.class);

   /**
     * @param arg0
     */
    public MessageRootMapConverter(Mapper arg0) {
        super(arg0);
     }


    public void marshal(Object value, HierarchicalStreamWriter writer,
                MarshallingContext context) {
     
        java.util.Map map = (java.util.Map) value;
        for (Iterator iter = map.keySet().iterator(); iter.hasNext();) {
            Object element = iter.next();
            writer.startNode(element.toString());
            writer.setValue(map.get(element).toString());
            writer.endNode();
            //if (log.isDebugEnabled()) {
            //    log.debug("Node ="+element+ "node value ="+map.get(element).toString());
            //}
        }
    }
    /** 
     * @param reader
     * @param context
     * @param map
     * @see com.thoughtworks.xstream.converters.collections.MapConverter#populateMap(com.thoughtworks.xstream.io.HierarchicalStreamReader, com.thoughtworks.xstream.converters.UnmarshallingContext, java.util.Map)
     */
    @SuppressWarnings("unchecked")
    @Override
    protected void populateMap(HierarchicalStreamReader reader, UnmarshallingContext context, Map map) {
        //super.populateMap(reader, context, map);
        for (; reader.hasMoreChildren(); reader.moveUp()) {
            Object key = reader.getNodeName();
            Object value = readItem(reader, context, map);
            reader.moveDown();
            if (log.isDebugEnabled()) {
                log.debug("Node ="+key+ "node value ="+value);
            }
            map.put(key, value);
        }

    }
   

}