/**
 * 
 */
package com.sonicsw.pso.demo.util;

import static com.sonicsw.pso.demo.util.IConstants.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.Set;

/**
 * @author Nick Rapoport - Copyright (c) - Apr 2, 2007 All rights reserved
 *
 */
public class Utilities  {
    private static final long serialVersionUID = 1L;
    private static final String DELIM_START = "${";
    private static final char DELIM_STOP = '}';
    private static final int DELIM_START_LEN = 2;
    private static final int DELIM_STOP_LEN = 1;
    //private static org.apache.log4j.Logger log = org.apache.log4j.Logger
    //        .getLogger(Utilities.class);

//    /**
//     * Utility method to return a connected instance of JMSConnectorClient
//     * 
//     * @return JMSConnectorClient
//     * @throws ConfigurationException
//     */
 //   public static JMSConnectorClient getConnectorClient(ConfigureSystem cs)
 //           throws ConfigurationException {
 //       return getConnectorClient(cs.getConnectionUrl(), cs.getUsername(), cs
 //               .getPassword());
 //   }
    
    /*
     * Utility method to return a connected instance of JMSConnectorClient
     * 
     * @return JMSConnectorClient
     * @throws ConfigurationException
     */
    /*
    public static JMSConnectorClient getConnectorClient(String url,
            String username, String password) throws ConfigurationException {
        JMSConnectorClient client;
        Hashtable<String, String> env = new Hashtable<String, String>();
        env.put(CONNECTION_URLS, url);
        env.put(DEFAULT_USER_NAME, username);
        env.put(DEFAULT_USER_PASSWORD, password);
        
        try {
            JMSConnectorAddress address = new JMSConnectorAddress(env);
            
            client = new JMSConnectorClient();
            client.connect(address, 60000);
        }
        catch (CommunicationException ce) {
            throw new ConfigurationException(
                    "Unable to make JMSConnectorClient connection", ce);
        }
        return client;
    }

    public static String getBrokerNameFromPath(String path) {
        String[] parts = path.split("/");
        if (parts!=null && parts.length > 1) {
            return parts[parts.length - 2];
        }
        return null;
    }
    */
    public static File validateAbsolutePath(String root) throws ConfigurationException {
        return validateAbsolutePath(root,"Directory \""+root+"\"",true);
    }
    public static File validateAbsolutePath(String root, String msg) throws ConfigurationException {
        return validateAbsolutePath(root,msg,true);
    }
    public static File validateAbsolutePath(String root, String msg,boolean create) throws ConfigurationException {
        File dir = new File(root);
        if (!dir.isAbsolute()) { 
            throw new ConfigurationException(
                    msg
                    + " must contain an absolute path.  Relative path \""
                        + root + "\" was found"); }
        
        if (!dir.exists()) {
            if ( create) {
                return createDirectory(dir);
            }
        } else {
            if (!dir.isDirectory()) { 
                throw new ConfigurationException(
                    msg
                    + " must contain a directory \""
                    + dir.getAbsolutePath()
                    + "\" exists, but is not a directory. \""
                        + root + "\" was found"); }
        }
        return dir;
    }
    
    public static File createDirectory(String root) throws ConfigurationException {
        File rootDir = new File(root);
        return createDirectory(rootDir);
    }
    
    public static File createDirectory(File dir ) throws ConfigurationException {
        if (dir.exists()) {
            if (!dir.isDirectory()) {
                throw new ConfigurationException("Directory \""
                        + dir.getAbsolutePath()
                        + "\" exists, but is not a directory.");
            }
        } else {
            if (!dir.mkdirs()) {
                throw new ConfigurationException(
                        "Unable to create directory \"" + dir
                                + "\"");
            }
        }
        return dir;
    }
    /**
     * @param key
     * @param value
     * @param validValues
     * @param errorMSG
     * @return
     * @throws ConfigurationException
     */

    public static boolean validateListRequired(String key, String value,
            Set validValues, String errorMSG)
            throws ConfigurationException {
        if (!validateList(value,validValues)) {
            throw new ConfigurationException(errorMSG + " " + key
                    + ", invalid value \"" + value + "\" Valid values are "
                    + validValues.toString());             
        }
        return true;
    }
    public static boolean validateList(String key, String value,
            Set validValues, String errorMSG)
            {
        if (!validateList(value,validValues)) {
            System.out.println(errorMSG + " " + key
                    + ", invalid value \"" + value + "\" Valid values are "
                    + validValues.toString());
            return false;
        }
        return true;
    }

    public static boolean validateList(String value,
            Set validValues) {
        if (!validValues.contains(value)) {
            return false;
        }
        return true;
    }

    
    /**
     * This method will properly format a multi-node path name for adding to
     * sonicfs from the passed string. 
     * @param path - the string representing the passed path
     * @return The reformatted path string with any redundant "/" removed and
     * a leading and trailing "/" added
     */
    public static String formatFolder(String path) {
        StringBuffer pathBuffer = new StringBuffer("/");
        String currentPath = pathBuffer.toString();
        String nodes[] = path.split("[/]+");
        for (int i = 0; i < nodes.length; i++) {
            if (nodes[i] != null && nodes[i].trim().length() > 0
                    && nodes[i].trim() != "/") {
                // System.out.println("nodes["+i+"]='"+nodes[i]+"'");
                pathBuffer.append(nodes[i]).append("/");
                currentPath = pathBuffer.toString();
            }
        }
        if (!currentPath.endsWith("/")) {
            pathBuffer.append("/");
            currentPath = pathBuffer.toString();
        }
        // System.out.println("created/verified path :"+currentPath);
        return currentPath;
        
    }

    public static void saveFile(String path, String name, String contents)
            throws ConfigurationException {
        saveFile(new File(path,name), contents);
    }

    public static void saveFile(String path, String contents)
            throws ConfigurationException {
        saveFile(new File(path), contents);
    }

    public static void saveFile(File file, String contents)
            throws ConfigurationException {
        FileWriter fw;
        try {
            fw = new FileWriter(file);
            fw.write(contents);
            fw.flush();
            fw.close();
        }
        catch (IOException ex) {
            throw new ConfigurationException("Caught IOException Message "
                    + ex.toString(), ex);
        }
        
    }
    
    public static void saveFile(File file, InputStream contents, long size)
            throws ConfigurationException {
        int buffSize = getBufferSize(size);
        FileChannel out;
        InputStreamReader sr;
        try {
            out = new FileOutputStream(file).getChannel();
            ByteBuffer buffer = ByteBuffer.allocate(buffSize);
            sr = new InputStreamReader(contents);
            while (sr.read(buffer.asCharBuffer()) != -1) {
                buffer.flip(); // Prepare for writing
                out.write(buffer);
                buffer.clear(); // Prepare for reading
            }
            sr.close();
            out.force(true);
            out.close();
        }
        catch (IOException ex) {
            throw new ConfigurationException("Caught IOException Message "
                    + ex.toString(), ex);
        }

}

    public static void copyFile(File fromDir,File toDir,String name) 
        throws ConfigurationException {
        if (fromDir.getAbsolutePath().equals(toDir.getAbsolutePath())) {
            return; //noting to be done here
        }
        toDir.mkdirs();
        
        File inFile = new File(fromDir,name);
        File outFile = new File(toDir,name);
        copyFile(inFile,outFile,0,false);
    }

    public static void copyFile(File source, File dest, boolean destDir)
            throws ConfigurationException {
        if (source.getAbsolutePath().equals(dest.getAbsolutePath())) {
            // noting to be done here
            return;
        }
        if (destDir) {
            dest.mkdirs();
        } else {
            dest.getParentFile().mkdirs();            
        }
        copyFile(source, dest);
    }

    public static void copyFile(File source, File dest)
            throws ConfigurationException {
        if (source.getAbsolutePath().equals(dest.getAbsolutePath())) {
            // noting to be done here
            return;
        }
        copyFile(source,dest,0,dest.isDirectory());
    }

    public static void copyFile(File source, File dest, int level, boolean targetDir)
            throws ConfigurationException {
        if (targetDir) {
            dest.mkdirs();
        } else {
            dest.getParentFile().mkdirs();
        }
        if (source.isDirectory() && dest.isDirectory()) {
            File[] allFiles = source.listFiles();
            for (int i = 0; i < allFiles.length; i++) {
                File file = allFiles[i];
                File newDest = new File(dest,file.getName());
                if (file.isDirectory()) {
                    copyFile(file,newDest,++level,true);
                } else {
                    copyFile(file,newDest,++level,false);
                }
            }
        } else if (dest.isDirectory() ) {
            dest = new File(dest,source.getName());
        }
        int buffSize = getBufferSize(source);
        if (buffSize < 1) { return; }
        
        FileChannel in;
        FileChannel out;
        try {
            in = new FileInputStream(source).getChannel();
            out = new FileOutputStream(dest).getChannel();
            ByteBuffer buffer = ByteBuffer.allocate(buffSize);
            
            while (in.read(buffer) != -1) {
                buffer.flip(); // Prepare for writing
                out.write(buffer);
                buffer.clear(); // Prepare for reading
            }
            in.close();
            out.force(true);
            out.close();
        }
        catch (IOException ex) {
            throw new ConfigurationException("Caught IOException Message "
                    + ex.toString(), ex);
        }
        
    }

    public static String getFileContent(File file) throws ConfigurationException {
        // Return file contents as a string
        int buffSize = getBufferSize(file);
        if (buffSize < 1) { return ""; }
        
        StringBuffer contents = new StringBuffer(buffSize);
        FileChannel in;
        try {
            in = new FileInputStream(file).getChannel();
            ByteBuffer buffer = ByteBuffer.allocate(buffSize);
            while (in.read(buffer) != -1) {
              buffer.flip(); // Prepare for writing
              contents.append(new String(buffer.array()));
              buffer.clear(); // Prepare for reading
            }
            in.close();
        }
        catch (IOException ex) {
            throw new ConfigurationException ("Caught IOException Message " + 
                    ex.toString(),ex);
        }
        contents.trimToSize();
        return contents.toString();
   }
    
    public static int getBufferSize(File file) {
        long fSize = file.length();
        return getBufferSize(fSize);
    }
    
    public static int getBufferSize(long fSize) {
        int buffSize = 65536; // use up to a 65K buffer for large files
        if (fSize < 1) { return 0; }
        
        if (fSize < buffSize) {
            buffSize = new Long(fSize).intValue();
        }        
        return buffSize;
    }
    

    public static StringBuffer fillIn(Throwable t,StringBuffer sb, String nest) {
        sb.append(nest).append(t.toString()).append("\n");
        StackTraceElement[] ste = t.getStackTrace();
        for (int i = 0; i < ste.length; i++) {
            StackTraceElement element = ste[i];
            sb.append(nest).append("at ").append(element.toString()).append("\n");
        }       
        return sb;
    }
    
    public static Throwable getCause(Throwable t) {
//        if (t instanceof MgmtException) {
//            MgmtException mgmt = (MgmtException) t;
//            return mgmt.getLinkedException();
//        } else if (t instanceof ConfigServiceRuntimeException) {
//            ConfigServiceRuntimeException csre = (ConfigServiceRuntimeException) t;
//            return csre.getLinkedException();
//        } 
        return t.getCause();
    }
    public static Throwable reflectCause(Throwable t) {
        try {
            Method m = t.getClass().getMethod("getLinkedException", NULL_PARAM);
            return (Throwable)m.invoke(t, (Object[])NULL_PARAM);
        }
        catch (NoSuchMethodException ex) {
            return t.getCause();
        }
        catch (Exception ex) {
            System.err.println("Caught Exception, Message " + 
                ex.toString()); //,ex);
            ex.printStackTrace(System.err);
        }
         return t.getCause();
    }
    
    public static String parseException(Throwable t) {
        String nest = "\t";
        StringBuffer sb =  fillIn( t,new StringBuffer(),nest);
        Throwable linked = reflectCause(t);
        if ((linked != null) ) {
            //
            // The underlying cause of the failure is placed in the linked
            // exception
            //
            while (linked != null) {
                nest+="\t";
                sb =  fillIn( linked,sb,nest);
                linked = reflectCause(linked);
            }
            
        }
        return sb.toString();
        
    }
/*
    public static String substVars(String val, ConfigProps props)
    throws IllegalArgumentException {
        StringBuffer sBuf = new StringBuffer();
        int i = 0;
        do {
            int j = val.indexOf(DELIM_START, i);
            if (j == -1) {
                    if (i == 0) {
                    return val;
                }
                sBuf.append(val.substring(i, val.length()));
                return sBuf.toString();
            }
            sBuf.append(val.substring(i, j));
            int k = val.indexOf(DELIM_STOP, j);
            if (k == -1) throw new IllegalArgumentException('"' + val
                    + "\" has no closing brace. Opening brace at position " + j
                    + '.');
            j += DELIM_START_LEN;
            String key = val.substring(j, k);
            //LogLog.debug("replacement-key="+key);
            String replacement = props.getProperty(key);
            //LogLog.debug("replacement="+replacement);
            if (replacement != null) {
                String recursiveReplacement = substVars(replacement, props);
                sBuf.append(recursiveReplacement);
            }
            i = k + DELIM_STOP_LEN;
        }
        while (true);
    }
*/
}
