using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Xml;
using System.Text.RegularExpressions;
using Microsoft.SqlServer.Server;
using System.Collections;
using System.Collections.Specialized;

namespace sonicsw.pso.sqlserver.procedures
{
    public partial class StoredProcedures
    {
        #region Properties
        private static object lockObject = new object();
        //private static string initResults = "";
        private static string connectResults = "";

        private static String destination = "Test.SQLServer.1";
        public static String Destination
        {
            get { return destination; }
            set { destination = value; }
        }
        private static JMSDestType destType = JMSDestType.TOPIC;
        public static JMSDestType DestType
        {
            get { return destType; }
            set { destType = value; }
        }
        private static String forwardDest = "";
        public static String ForwardDest
        {
            get { return forwardDest; }
            set { forwardDest = value; }
        }
        //private static JMSDestType forwardDestType = JMSDestType.QUEUE;
        //public static JMSDestType ForwardDestType
        //{
        //    get { return forwardDestType; }
        //    set { forwardDestType = value; }
        //}

        private static String connectionURLs = "tcp://nrapoporxp:2506";
        public static String ConnectionURLs
        {
            get { return connectionURLs; }
            set { connectionURLs = value; }
        }
        private static String userName = "Administrator";
        public static String UserName
        {
            get { return userName; }
            set { userName = value; }
        }
        private static String userPassword = "Administrator";
        public static String UserPassword
        {
            get { return userPassword; }
            set { userPassword = value; }
        }

        private static Producer msgProducer;
        public static Producer MsgProducer
        {
            get
            {
                if (msgProducer == null)
                {
                    lock (lockObject)
                    {
                        if (msgProducer == null)
                        {
                            msgProducer = new Producer();
                            connectResults = msgProducer.configure(ConnectionURLs, UserName, UserPassword, Destination, DestType);
                        }
                    }

                }
                return msgProducer;
            }
            set
            {
                lock (lockObject)
                { msgProducer = value; }
            }
        }
        private static Consumer msgConsumer;
        public static Consumer MsgConsumer
        {
            get
            {
                if (msgConsumer == null)
                {
                    lock (lockObject)
                    {
                        if (msgConsumer == null)
                        {
                            msgConsumer = new Consumer();
                            connectResults = msgConsumer.configure(ConnectionURLs, UserName, UserPassword, Destination, DestType, ForwardDest);
                        }
                    }

                }
                return msgConsumer;
            }
            set
            {
                lock (lockObject)
                { msgConsumer = value; }
            }
        }
        #endregion

        #region Stored Procedures

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ConfigureSonicEnv(String url,String user, String pass,String destNameIn, string destTypeStr, ref String status)
        {
            ConfigureSonicForwardEnv(url, user, pass, destNameIn, destTypeStr, "", ref status);
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static void ConfigureSonicForwardEnv(String url, String user, String pass, String destNameIn, string destTypeStr, string forwaredDestStr, ref String status)
        {
            try
            {
                connectionURLs = url;
                userName = user;
                destination = destNameIn;
                forwardDest = forwaredDestStr;
                userPassword = pass;
                destType = (JMSDestType)Enum.Parse(typeof(JMSDestType), destTypeStr, true);
                status = "Configuration Successful";
                if (msgProducer != null)
                {
                    MsgProducer.Dispose();
                    MsgProducer = null;
                }
                if (msgConsumer != null)
                {
                    MsgConsumer.Dispose();
                    MsgConsumer = null;
                }
            }
            catch (Exception ex)
            {
                StringBuilder sb = new StringBuilder("ERROR in ConfigureSonicEnv : ").Append(ex.ToString());
                status = sb.ToString();
            }
        }


        [Microsoft.SqlServer.Server.SqlProcedure]
        public static Int32 SendProc(String data, ref String results)
        {
            Int32 statusInt = 1;
            string status = "";
            if (connectResults.StartsWith("ERROR"))
            {
                connectResults = "";
                MsgProducer = null;
            }
            Producer p = MsgProducer;
            if (connectResults.StartsWith("ERROR"))
            {
                status = connectResults;
                statusInt = -1;
            } 
            else 
            {
                status = p.Send(data);
                if (status.StartsWith("ERROR"))
                {
                    statusInt = -1;
                }
            }
            results = status;
            return statusInt;
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static Int32 SendTypedProc(String data, String type, ref String results)
        {
            Int32 statusInt = 1;
            string status = "";
            if (connectResults.StartsWith("ERROR"))
            {
                connectResults = "";
                MsgProducer = null;
            }
            Producer p = MsgProducer;
            if (connectResults.StartsWith("ERROR"))
            {
                status = connectResults;
                statusInt = -1;
            }
            else
            {
                status = p.Send(data, (JMSMessageType)Enum.Parse(typeof(
                    JMSMessageType),type,true));
                if (status.StartsWith("ERROR"))
                {
                    statusInt = -1;
                }
            }
            results = status;
            return statusInt;
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static Int32 ReceiveProcNoWait(ref String results)
        {
            return ReceiveProc(0L, ref results);
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static Int32 ReceiveProcNoTimeout(ref String results)
        {
            return ReceiveProc(-1L, ref results);
        }

        [Microsoft.SqlServer.Server.SqlProcedure]
        public static Int32 ReceiveProc(long timeout, ref String results)
        {
            Int32 statusInt = 1;
            results = "";
            if (connectResults.StartsWith("ERROR"))
            {
                connectResults = "";
                MsgConsumer = null;
            }
            Consumer c = MsgConsumer;
            if (connectResults.StartsWith("ERROR"))
            {
                results = connectResults;
                statusInt = -1;
            }
            else
            {
                results = c.Receive(timeout);
                if (results.StartsWith("ERROR"))
                {
                    statusInt = -1;
                }
            }
            return statusInt;
        }
        
        #endregion

    };

    public class CLRTriggers
    {
        #region Properties

        public static StoredProcedures sp;
        #endregion

        #region Triggers
        [SqlTrigger(Name = @"tr_MessageStor", Target = "MessageStor", Event = "FOR INSERT, UPDATE, DELETE")]
        public static void SendNotification()
        {
            string messageKey;
            string message;
            SqlCommand command;
            SqlTriggerContext triggContext = SqlContext.TriggerContext;
            SqlPipe pipe = SqlContext.Pipe;
            SqlDataReader reader;
            String status = "";
            if (sp == null)
            {
                sp = new StoredProcedures();
                StoredProcedures.ConfigureSonicEnv(
                        @"tcp://nrapoporxp:2506",
                        @"Administrator",
                        @"Administrator",
                        @"Sample.Q5",
                        @"queue",
                        ref status);         
            }

            switch (triggContext.TriggerAction)
            {
                case TriggerAction.Insert:
                    // Retrieve the connection that the trigger is using
                    using (SqlConnection connection
                       = new SqlConnection(@"context connection=true"))
                    {
                        connection.Open();
                        command = new SqlCommand(@"SELECT * FROM INSERTED;",
                           connection);
                        reader = command.ExecuteReader();

                        while(reader.Read()) {
                            messageKey = (string)reader[0];
                            message = (string)reader[1];
                            MessageStorOperation mso = 
                                new MessageStorOperation(
                                    new MessageStorRow("new",messageKey,message),"insert");
                            StoredProcedures.SendTypedProc(mso.ToString(), "XML", ref status);
                        }
                        reader.Close();
                    }

                    break;
                case TriggerAction.Delete:
                    using (SqlConnection connection
                       = new SqlConnection(@"context connection=true"))
                    {
                        connection.Open();
                        command = new SqlCommand(@"SELECT * FROM DELETED;",
                           connection);
                        reader = command.ExecuteReader();

                        if (reader.HasRows)
                        {
                            while (reader.Read())
                            {
                                messageKey = (string)reader[0];
                                message = (string)reader[1];

                                MessageStorOperation mso =
                                    new MessageStorOperation(
                                        new MessageStorRow("old", messageKey, message), "delete");
                                StoredProcedures.SendTypedProc(mso.ToString(), "XML", ref status);
                            }
                        }
                        else
                        {
                            //alternately, to just send a an null row message:
                            MessageStorOperation mso =
                                new MessageStorOperation(
                                    new MessageStorRow("old", "", ""), "delete");
                            StoredProcedures.SendTypedProc(mso.ToString(), "XML", ref status);
                        }
                        reader.Close();
                    }

                    break;

                case TriggerAction.Update:
                    // Retrieve the connection that the trigger is using
                    using (SqlConnection connection
                       = new SqlConnection(@"context connection=true"))
                    
                    {
                        connection.Open();
                        command = new SqlCommand(@"SELECT * FROM DELETED;",
                           connection);
                        reader = command.ExecuteReader();
                        ArrayList updates = new ArrayList();
                        while (reader.Read())
                        {
                            messageKey = (string)reader[0];
                            message = (string)reader[1];
                            UpdateMessageStorOperation umso =
                              new UpdateMessageStorOperation(
                                  new MessageStorRow("old", messageKey, message));
                            updates.Add(umso);
                        }
                        reader.Close();
                        
                        int cntr = 0;
                        command = new SqlCommand(@"SELECT * FROM INSERTED;",connection);
                        reader = command.ExecuteReader();

                        while (reader.Read())
                        {
                            messageKey = (string)reader[0];
                            message = (string)reader[1];
                            UpdateMessageStorOperation umso =
                                (UpdateMessageStorOperation) updates[cntr++];
                            umso.NewRow = new MessageStorRow("new", messageKey, message);
                            StoredProcedures.SendTypedProc(umso.ToString(), "XML", ref status);
                        }

                        reader.Close();
                    }

                    break;

            }
        }

        #endregion

    }

    #region Data Objects
    public class MessageStorRow
    {
        public MessageStorRow(string rowTypeIn, string key, string msg)
        {
            messageKey = key;
            message = msg;
            rowType = rowTypeIn;
        }

        private String rowType = "";
        public String RowType
        {
            get { return rowType; }
            set { rowType = value; }
        }


        private String messageKey = "";
        public String MessageKey
        {
            get { return messageKey; }
            set { messageKey = value; }
        }

        private String message = "";
        public String Message
        {
            get { return message; }
            set { message = value; }
        }

        public override string ToString()
        {
            return "<Row type='" + RowType + "'><MessageKey>" +
                   messageKey + "</MessageKey><Message>" + message +
                   "</Message></Row>";
        }
    }
    
    public class MessageStorOperation
    {
        public MessageStorOperation(MessageStorRow rowIn, string type)
        {
            row = rowIn;
            operationType = type;
        }
        private MessageStorRow row;
        public MessageStorRow Row
        {
            get { return row; }
            set { row = value; }
        }
        private String operationType = "";
        public String OperationType
        {
            get { return operationType; }
            set { operationType = value; }
        }
        public override string ToString()
        {
            return "<Operation type='"+operationType+"'>"+row+"</Operation>";
        }
    }
    
    public class UpdateMessageStorOperation : MessageStorOperation
    {
        public UpdateMessageStorOperation(MessageStorRow rowIn, MessageStorRow newRowIn)
            : base(rowIn, "update")
        {
            newRow = newRowIn;
        }
        public UpdateMessageStorOperation(MessageStorRow rowIn)
            : base(rowIn, "update") {}

        private MessageStorRow newRow;
        public MessageStorRow NewRow
        {
            get { return newRow; }
            set { newRow = value; }
        }
        public override string ToString()
        {
            return "<Operation type='" + OperationType + "'>" + Row + newRow + "</Operation>";
        }

    }
    #endregion
}
