-- Examples for queries that exercise different SQL objects implemented by this assembly

-----------------------------------------------------------------------------------------
-- Stored procedure
-----------------------------------------------------------------------------------------
-- exec StoredProcedureName


-----------------------------------------------------------------------------------------
-- User defined function
-----------------------------------------------------------------------------------------
-- select dbo.FunctionName()


-----------------------------------------------------------------------------------------
-- User defined type
-----------------------------------------------------------------------------------------
-- CREATE TABLE test_table (col1 UserType)
-- go
--
-- INSERT INTO test_table VALUES (convert(uri, 'Instantiation String 1'))
-- INSERT INTO test_table VALUES (convert(uri, 'Instantiation String 2'))
-- INSERT INTO test_table VALUES (convert(uri, 'Instantiation String 3'))
--
-- select col1::method1() from test_table



-----------------------------------------------------------------------------------------
-- User defined type
-----------------------------------------------------------------------------------------
-- select dbo.AggregateName(Column1) from Table1


--select 'To run your project, please edit the Test.sql file in your project. This file is located in the Test Scripts folder in the Solution Explorer.'
use testdb
--go
set nocount on

declare @url varchar(100)
		,@user varchar(100)
		,@password varchar(100)
		,@destination varchar(100)
		,@dest_type varchar(100)
		,@forward_dest varchar(100)
		
		,@data varchar(100) 
		,@result varchar(100)
		,@start datetime 
		,@counter int
		,@maxCount int
select @result=''
		,@url = 'tcp://nrapoporxp:2506'
		,@user = 'Administrator'
		,@password = 'Administrator'
		,@destination = 'Sample.Q6'
		,@dest_type ='queue'
		,@forward_dest ='Sample.Q7'

-- the forwarding only works with queues!!!!!!!!!!!!!!!!!!!!
print N'====================================='
print N'Configuring Connection properties'
print N'====================================='
print N'@url          = '+@url
print N'@user         = '+@user
print N'@password     = '+@password
print N'@destination  = '+@destination
print N'@dest_type    = '+@dest_type
print N'@forward_dest = '+@forward_dest
print N'====================================='


exec dbo.ConfigureSonicForwardEnv @url 
						,@user
						,@password
						,@destination
						,@dest_type
						,@forward_dest
						,@result output
						
print convert(varchar(45),@result) 

print N'====================================='


select	@start=getdate()
		,@data='TEST MEssage '
		,@result=''
		,@counter=0
		,@maxCount=10

print N' '

print N' Send '+ltrim(convert(varchar(8),@maxCount))
	+ ' messages to '''+@destination+''' '+@dest_type
	

while (@counter < @maxCount)
begin 
	select @counter=(@counter+1)
			,@data='TEST MEssage '+convert(varchar(8),@counter)
	
	exec dbo.SendProc @data,@result output
end

print N'====================================='
print N' '
select @counter as 'Msg Count'
	, convert(numeric(11,4),
		convert(numeric(11,4),
		datediff(ms,@start,getdate()))/1000) as 'Elapsed Time (sec)'
	,convert(varchar(30),@data) as 'Last Message'
	,convert(varchar(20),@result) as 'Status'

print N' '
print N'=================================================================='
print N'Receive from '+@dest_type+' '''+@destination
	+''' and forward messages to '''+@forward_dest+''''
print N'=================================================================='


select @counter=0
while (@counter < @maxCount)
begin 
	select @result=''
	exec dbo.ReceiveProcNoWait @result output	
	select @counter=(@counter+1)
	print 'Receive & Forward Results = '+convert(varchar(45),@result)
end
--go