using System;
using System.Collections.Generic;
using System.Text;

namespace sonicsw.pso.utilities
{
    public enum FlowToDisk : int
    {
        USE_BROKER_SETTING = Sonic.Jms.Ext.Constants.FLOW_TO_DISK_USE_BROKER_SETTING,
        FLOW_TO_DISK_ON = Sonic.Jms.Ext.Constants.FLOW_TO_DISK_ON,
        FLOW_TO_DISK_OFF = Sonic.Jms.Ext.Constants.FLOW_TO_DISK_OFF,
        DEFAULT_FLOW_TO_DISK = Sonic.Jms.Ext.Constants.DEFAULT_FLOW_TO_DISK
    }
    
    public enum JMSCommType
    {
        PRODUCER = 0,
        CONUSMER = 1
    }

    public enum JMSDestType
    {
        QUEUE = 0,
        TOPIC = 1
    }
    
    [Flags]
    public enum JMSHeaderProps
    {
        JMSDestination = 0,
        JMSDeliveryMode = 1,
        JMSMessageID = 2,
        JMSTimestamp = 4,
        JMSCorrelationID = 8,
        JMSReplyTo = 16,
        JMSRedelivered = 32,
        JMSType = 64,
        JMSExpiration = 128,
        JMSPriority = 256
    }
    
    [Flags]
    public enum JMSMessageType
    {
        TEXT,
        MAP,
        OBJECT,
        BYTES,
        STREAM,
        XML,
        MULTIPART
    }

    public enum JMSAckMode : int
    {
        AUTO_ACKNOWLEDGE = Sonic.Jms.SessionMode.AUTO_ACKNOWLEDGE,
        CLIENT_ACKNOWLEDGE = Sonic.Jms.SessionMode.CLIENT_ACKNOWLEDGE,
        DUPS_OK_ACKNOWLEDGE = Sonic.Jms.SessionMode.DUPS_OK_ACKNOWLEDGE,
        SESSION_TRANSACTED = Sonic.Jms.SessionMode.SESSION_TRANSACTED,
        SINGLE_MESSAGE_ACKNOWLEDGE = Sonic.Jms.Ext.SessionMode.SINGLE_MESSAGE_ACKNOWLEDGE
    }

    public enum JmsConnectionStates : int
    {
        ACTIVE = Sonic.Jms.Ext.Constants.ACTIVE,
        RECONNECTING = Sonic.Jms.Ext.Constants.RECONNECTING,
        FAILED = Sonic.Jms.Ext.Constants.FAILED,
        CLOSED = Sonic.Jms.Ext.Constants.CLOSED
    }


    class Constants
    {
        public const string TIME_STAMP_FORMAT = "yyyy/MM/dd HH:mm:ss.fffffff";

    }
}
