using System;
using System.Collections.Generic;
using System.Text;

namespace sonicsw.pso.utilities
{
        public delegate void RaiseJMSMessageDel(Object sender, JMSMessageEventArgs e);
        public delegate void RaiseJMSExceptionDel(Object sender, JMSExceptionEventArgs e);
        public delegate void RaiseJMSConnectionStateDel(Object sender, JMSConnectionStateEventArgs e);


    public interface IJMSAccessDisplay : IProcessTrace
    {
        System.Collections.Hashtable Props
        {
            get;
            set;
        }

        void ProcessJMSMessage(Object sender, JMSMessageEventArgs e);
        void ProcessJMSException(Object sender, JMSExceptionEventArgs e);
        void ProcessJMSConnectionState(Object sender, JMSConnectionStateEventArgs e);

        void RaiseJMSMessage(Object sender, JMSMessageEventArgs e);
        void RaiseJMSException(Object sender, JMSExceptionEventArgs e);
        void RaiseJMSConnectionState(Object sender, JMSConnectionStateEventArgs e);

        event EventHandler<JMSMessageEventArgs> JMSMessage;
        event EventHandler<JMSExceptionEventArgs> JMSException;
        event EventHandler<JMSConnectionStateEventArgs> JMSConnectionState;
        
    }

    public class JMSExceptionEventArgs : EventArgs
    {
        public JMSExceptionEventArgs(Sonic.Jms.JMSException exceptionIn)
        {
            this.exception = exceptionIn;
        }
        private Sonic.Jms.JMSException exception;

        public Sonic.Jms.JMSException JMSException
        {
            get { return exception; }
            set { exception = value; }
        }

    }
    public class JMSMessageEventArgs : EventArgs
    {
        public JMSMessageEventArgs(Sonic.Jms.Message messageIn)
        {
            this.message = messageIn;
        }
        private Sonic.Jms.Message message;

        public Sonic.Jms.Message Message
        {
            get { return message; }
            set { message = value; }
        }

    }
    public class JMSConnectionStateEventArgs : EventArgs
    {
        public JMSConnectionStateEventArgs(JmsConnectionStates stateIn)
        {
            this.state = stateIn;
        }
        private JmsConnectionStates state;

        public JmsConnectionStates State
        {
            get { return state; }
            set { state = value; }
        }

        public string getStateName() 
        {
            return Enum.GetName(typeof(JmsConnectionStates), state);
        }

    }

}
