using System;
using System.Collections.Generic;
using System.Text;

namespace sonicsw.pso.utilities
{
    public delegate void RaiseTraceExceptionDel(Object sender, TraceExceptionEventArgs e);
    public delegate void RaiseWriteTraceDel(object sender, WriteTraceEventArgs e);

    public interface IProcessTrace
    {
        void ProcessWriteTrace(Object sender, WriteTraceEventArgs e);
        void ProcessTraceException(Object sender, TraceExceptionEventArgs e);

        void RaiseWriteTrace(Object sender, WriteTraceEventArgs e);
        void RaiseTraceException(Object sender, TraceExceptionEventArgs e);

        event EventHandler<WriteTraceEventArgs> WriteTrace;
        event EventHandler<TraceExceptionEventArgs> TraceException;

    }
    public class WriteTraceEventArgs : EventArgs
    {
        public WriteTraceEventArgs(String prefixIn, String dataIn, System.Drawing.Color colorIn)
        {
            this.prefix = prefixIn;
            this.data = dataIn;
            this.color = colorIn;
        }
        private String prefix;

        public String Prefix
        {
            get { return prefix; }
            set { prefix = value; }
        }
        private String data;

        public String Data
        {
            get { return data; }
            set { data = value; }
        }
        private System.Drawing.Color color;

        public System.Drawing.Color Color
        {
            get { return color; }
            set { color = value; }
        }

    }
    public class TraceExceptionEventArgs : EventArgs
    {
        public TraceExceptionEventArgs(String prefixIn, Exception exceptionIn)
        {
            this.prefix = prefixIn;
            this.exception = exceptionIn;
        }
        private String prefix;

        public String Prefix
        {
            get { return prefix; }
            set { prefix = value; }
        }
        private Exception exception;

        public Exception Exception
        {
            get { return exception; }
            set { exception = value; }
        }

    }

}
