using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.Configuration;

namespace sonicsw.pso.utilities
{
    public class Utilities
    {
        private static log4net.ILog log = log4net.LogManager.GetLogger(
            System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        
        public static string TimeStampString(string prefix, string str_value)
        {
            StringBuilder work = new StringBuilder(DateTime.Now.ToString(Constants.TIME_STAMP_FORMAT));
            work.Append(":");
            work.Append(prefix);
            work.Append(":");
            work.Append(str_value);
            return work.ToString();
        }

        public static object TestValue(String Key, ApplicationSettingsBase settings)
        {
            Object prop = null;
            try { prop = settings[Key]; }
            catch { }
            return prop;
        }

        #region Reflection Methods
        public static object GetPropertyValue(Object instance, string name)
        {
            try
            {
                MethodInfo method = instance.GetType().GetMethod("get" + name,
                    new Type[] { });
                if(method!=null) 
                {
                    return method.Invoke(instance, new Object[] { });
                }
            }
            catch (Exception ex)
            {
                log.Error("Error getting property, " + name + " : ", ex);
            }
            return null;
        }


        #endregion


        #region File Methods
        public static StreamWriter CreateStreamWriter(string filename)
        {
            StreamWriter sw = null;
            try
            {
                FileStream fs = new FileStream(filename, FileMode.Append, FileAccess.Write, FileShare.ReadWrite);
                sw = new StreamWriter(fs);
            }
            catch (Exception ex)
            {
                System.Console.Error.WriteLine("Error creating file :" + ex.GetType().Name);
                System.Console.Error.WriteLine("Error creating file :" + ex.Message);
                System.Console.Error.WriteLine("Error creating file :" + ex.StackTrace);
            }
            return sw;
        }
        public static bool WriteToFile(StreamWriter sw, string data)
        {
            try
            {
                sw.Write(data);
                sw.Flush();
                return true;
            }
            catch (Exception ex)
            {
                System.Console.Error.WriteLine("Error creating file :" + ex.GetType().Name);
                System.Console.Error.WriteLine("Error creating file :" + ex.Message);
                System.Console.Error.WriteLine("Error creating file :" + ex.StackTrace);
            }
            return false;
        }
        public static bool CloseFile(StreamWriter sw)
        {
            try
            {
                sw.Flush();
                sw.Close();
                sw.BaseStream.Close();
                return true;
            }
            catch (Exception ex)
            {
                System.Console.Error.WriteLine("Error creating file :" + ex.GetType().Name);
                System.Console.Error.WriteLine("Error creating file :" + ex.Message);
                System.Console.Error.WriteLine("Error creating file :" + ex.StackTrace);
            }
            return false;
        }
        #endregion

    }
}
