/*------------------------------------------------------------------------
    File        : P2P/TempTableP2PSendClientPersistence.p
    Purpose     : Send a temp-table message to a Sonic Queue 
  ----------------------------------------------------------------------*/

{common/define-ttCust.i}
{common/populate-ttCust.i}

{common/connectToSonicBrokerClientPersistence.i}

/* Create a message */
RUN createTempTableMessage IN hSession (OUTPUT hMessage).
RUN setTempTable IN hMessage (TEMP-TABLE ttCust:HANDLE, ?, ?).

/* Send the message to "SampleQ1" */
RUN sendToQueue IN hSession ("SampleQ1", hMessage, ?, ?, ?).

MESSAGE "Temp-Table message sent to SampleQ1 (Client Persistence)"
  VIEW-AS ALERT-BOX.

/* Clean up - Delete message and session */
RUN deleteMessage IN hMessage.
RUN deleteSession IN hSession.

