/*------------------------------------------------------------------------
    File        : PubSub/TTPubSubSend.p
    Purpose     : Send a temp-table message to a Sonic Topic 
  ----------------------------------------------------------------------*/

{common/define-ttCust.i}
{common/populate-ttCust.i}

{common/connectToSonicBroker.i}

/* Create a message */
RUN createTempTableMessage IN hSession (OUTPUT hMessage).
RUN setTempTable IN hMessage (TEMP-TABLE ttCust:HANDLE, ?, ?).

/* Send the message to "SampleQ1" */
RUN publish IN hSession ("SampleTopic1", hMessage, ?, ?, ?).

MESSAGE "Temp-Table message sent to SampleTopic1"
  VIEW-AS ALERT-BOX.

/* Clean up - Delete message and session */
RUN deleteMessage IN hMessage.
RUN deleteSession IN hSession.

